/* Rohan Murty (rnm5)
 * Sound Server written using minithreads!
 *
 */

#include <stdio.h>
#include <string.h>
#include "defs.h"
#include "minithread.h"
#include "minimsg.h"
#include "synch.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define BUFFER_SIZE 7500
#define MAX_COUNT 100

char* hostname;

int transmit_first(int* arg) {
  char buffer[BUFFER_SIZE];
  char rcv[1];
  int length = BUFFER_SIZE,lent=1;
  int i;
  network_address_t addr;
  miniport_t port,from;
  miniport_t dest;
  FILE *ptr;

  AbortOnCondition(network_translate_hostname(hostname, addr) < 0,
		   "Could not resolve hostname, exiting.");


  printf("\nStreaming on port 8086\n");
  ptr = fopen("sndfile1.au","rb");
  if (ptr==NULL) {
   printf("\nError opening sound file!");
   exit(0);
  }
  fseek(ptr,0,SEEK_SET);

  port = miniport_local_create();
  dest = miniport_remote_create(addr, 0);

  printf("\nBeginning to stream...\n");
  for (i=0; i<MAX_COUNT; i++) {
    fread(&buffer,1,BUFFER_SIZE,ptr);
    minimsg_send(port, dest, buffer, BUFFER_SIZE);
	/*printf("\nSending....%d",i);*/
	minimsg_receive(port, &from, rcv, &lent);
	/*printf("\nACKED!");*/
	miniport_destroy(from);
  }
  return 0;
}

void main(int argc, char **argv) {
  printf("\n****minithreads sound server****\n");
  if (argc > 1) {
    hostname = argv[1];
    minithread_system_initialize(transmit_first, NULL);
  }
  else {
   printf("\nUsage: <sndserver> remote_hostname");
  }   
}
